unit roundrect1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls,
  BGRABitmap,BGRADefaultBitmap, BGRABitmapTypes;

type

		{ TForm1 }

  TForm1 = class(TForm)
				Button1: TButton;
				Button2: TButton;
				Image1: TImage;
				procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

function Round4Rects (wi,hi: Integer) : TBGRABitmap;
const rx : array[0..3] of single = (30,10,60,120);
      ry : array[0..3] of single = (30,140,10,40);

var corn : array[0..3] of TBGRABitmap;
    master, tmp: TBGRABitmap;
    i, x,y : integer;

begin
master := TBGRABitmap.Create(wi,hi) ;
master.GradientFill(0,0,wi,hi, cssLime,cssBlue, gtRadial, PointF(0,0),PointF(wi,hi),dmSet);
tmp := TBGRABitmap.Create;
for i := 0 to 3 do
   begin
     corn[i] := TBGRABitmap.create(wi,hi);
     corn[i].RoundRectAntialias(20,20,wi-20,hi-20,rx[i],ry[i],cssblack,3,cssHotPink,[]);
     case i of
         0: begin x := 0; y := 0; end;  // topleft
         1: begin x := wi div 2; y := 0;end;  // topright
         2: begin x := wi div 2; y := hi div 2;end;  // bottomright
         3: begin x := 0; y := hi div 2;end; // bottomleft
         end; // case
     tmp := TBGRABitmap(corn[i].GetPart(Rect(x,y,x+wi div 2,y+hi div 2)) );
     master.PutImage(x,y,tmp,dmDrawWithTransparency);
     corn[i].free; // if you want to use it for later use then delete it here
     end; // i
result := master;
tmp.free;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  close;
end;

procedure TForm1.Button1Click(Sender: TObject);
var Corners : TBGRABitmap;
begin
corners := Round4Rects(Image1.width,image1.height);
corners.Draw(Image1.canvas,0,0);
corners.SaveToFile(ExtractFilePath(application.ExeName)+'Corners.png');
corners.free;
end;

end.

